﻿/*
Copyright (c) 2003-2012, CKSource - Frederico Knabben. All rights reserved.
For licensing, see LICENSE.html or http://ckeditor.com/license
*/

/*global define, top*/
/*jslint plusplus: true, ass: true, nomen: true, sub: true*/

define("ckeditor/config", [
    "module",
    "ckeditor/ckeditor",

    // Hack: Currently some plugins using direct access to ep.dict
    "ep/dict"
], function (mod, CKEDITOR) {
    'use strict';

    CKEDITOR.config.allowedContent = true;

    // Disable the resizing feature of dialogs completely
    CKEDITOR.on('dialogDefinition', function (ev) {
        ev.data.definition.resizable = CKEDITOR.DIALOG_RESIZE_NONE;
        ev.data.definition.minWidth = 500;
    });

    // Maybe config is already initialized and/or inherited from parent frame (MBO if SF is in editor mode)
    CKEDITOR.editorConfig = CKEDITOR.editorConfig || function (config) {

        // Define changes to default configuration here
        config.language = top.ep.config.language;
        config.plugins = CKEDITOR.config.plugins + ',find,sharedspace,eplineheight,epcolorbutton,eptextaligngroup,epalmostfullscreen,eplistgroup,eptableclass,eptable,eponchange';
        config.removePlugins = 'elementspath,magicline';
        config.font_names =
            'Arial/Arial, Verdana, Helvetica;' +
            'Courier New/Courier New, Verdana, Helvetica;' +
            'Georgia/georgia, Times New Roman, arial, sans-serif;' +
            'Lucida Sans/Lucida Sans Unicode, Lucida Sans, Verdana, Helvetica;' +
            'Tahoma/Tahoma, Verdana, Helvetica;' +
            'Times New Roman/Times New Roman, Times;' +
            'Trebuchet MS/Trebuchet MS, Verdana, Arial, Helvetica;' +
            'Verdana/Verdana, Arial, Helvetica';
        config.resize_enabled = false;
        config.toolbarCanCollapse = false;
        config.skin = 'epages';
        config.bodyClass = 'cke_Content';
        config.baseFloatZIndex = 480;

        // don't use HTML entities in the output
        config.entities = false;

        // make possible to take over text styles from word
        config.pasteFromWordRemoveFontStyles = false;

        // Read module config
        var moduleConfig = mod.config() || {},
            dataSort = [],
            dataStack = {},
            groups = {},
            plugin,
            _key,
            position,
            i;

        if (moduleConfig.contentsCss) {
            config.contentsCss = moduleConfig.contentsCss;
        }

        if (moduleConfig.plugins) {
            // Make plugins sortable
            for (_key in moduleConfig.plugins) {
                if (moduleConfig.plugins.hasOwnProperty(_key)) {
                    plugin = moduleConfig.plugins[_key];

                    if (dataSort.indexOf(plugin.position) === -1) {
                        dataSort.push(plugin.position);
                    }
                    (dataStack[plugin.position] || (dataStack[plugin.position] = [])).push(plugin);
                }
            }
            // Sort plugins

            dataSort = dataSort.sort();

            // Initialize plugins
            for (position in dataSort) {
                if (dataSort.hasOwnProperty(position)) {
                    for (i in dataStack[dataSort[position]]) {
                        if (dataStack[dataSort[position]].hasOwnProperty(i)) {
                            plugin = dataStack[dataSort[position]][i];

                            config.plugins += ',' + plugin.name;

                            if (plugin.group) {
                                (groups[plugin.group] || (groups[plugin.group] = [])).push(plugin.name);
                            }
                        }
                    }
                }
            }
        }

        if (groups["media"]) {
            config.plugins += ',epmediagroup';
        } else {
            groups["media"] = [];
        }

        groups["media_light"] = [];
        // remove rss gadet for non almost fullscreen toolbars
        for (_key in groups["media"]) {
            if (groups["media"].hasOwnProperty(_key)) {
                if (groups["media"][_key] !== "eprss") {
                    groups["media_light"].push(groups["media"][_key]);
                }
            }
        }

        if (groups["various"]) {
            groups["various"].push('Unlink');
        } else {
            groups["various"] = [];
        }

        config.toolbar = 'Full';

        config.toolbar_Full = [
            { name: 'styles', items : [ 'Undo', 'Redo', 'Format', 'Font', 'FontSize', 'RemoveFormat', 'Bold', 'Italic', 'Underline', 'eptextcolor' ] },
            { name: 'paragraph', items : [ 'NumberedList', 'BulletedList', 'Outdent', 'Indent', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock', 'eplineheight' ] },
            { name: 'media', items : groups["media_light"] },
            { name: 'various', items : groups["various"].concat(['eptable']) },
            { name: 'tools', items : [ 'Source' ] },
            { name: 'fullscreen', items : [ 'epalmostfullscreen' ] }
        ];

        config.toolbar_FullPageBreak = [
            { name: 'styles', items : [ 'Undo', 'Redo', 'Format', 'Font', 'FontSize', 'RemoveFormat', 'Bold', 'Italic', 'Underline', 'eptextcolor' ] },
            { name: 'paragraph', items : [ 'NumberedList', 'BulletedList', 'Outdent', 'Indent', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock', 'eplineheight' ] },
            { name: 'media', items : groups["media_light"] },
            { name: 'various', items : groups["various"].concat(['eptable']).concat(groups["forum"]) },
            { name: 'tools', items : [ 'Source' ] },
            { name: 'fullscreen', items : [ 'epalmostfullscreen' ] }
        ];

        // Configuration for display size 1280*768
        config.toolbar_Mini = [
            { name: 'styles', items : [ 'Undo', 'Redo', 'Format', 'Font', 'FontSize', 'RemoveFormat', 'Bold', 'Italic', 'Underline', 'eptextcolor' ] },
            { name: 'paragraph', items : [ 'NumberedList', 'BulletedList', 'Outdent', 'Indent', 'eptextaligngroup', 'eplineheight' ] },
            { name: 'media', items : groups["media_light"] },
            { name: 'various', items : groups["various"].concat(['eptable']) },
            { name: 'tools', items : [ 'Source' ] },
            { name: 'fullscreen', items : [ 'epalmostfullscreen' ] }
        ];

        config.toolbar_MiniPageBreak = [
            { name: 'styles', items : [ 'Undo', 'Redo', 'Format', 'Font', 'FontSize', 'RemoveFormat', 'Bold', 'Italic', 'Underline', 'eptextcolor' ] },
            { name: 'paragraph', items : [ 'eplistgroup', 'Outdent', 'Indent', 'eptextaligngroup', 'eplineheight' ] },
            { name: 'media', items : groups["media_light"] },
            { name: 'various', items : groups["various"].concat(['eptable']).concat(groups["forum"]) },
            { name: 'tools', items : [ 'eptable', 'Source' ] },
            { name: 'fullscreen', items : [ 'epalmostfullscreen' ] }
        ];

        config.toolbar_Fullscreen = [
            { name: 'styles', items : [ 'Undo', 'Redo', 'Find', 'Format', 'Font', 'FontSize', 'RemoveFormat', 'Bold', 'Italic', 'Underline', 'Strike', 'eptextcolor', 'epbgcolor' ] },
            { name: 'paragraph', items : [ 'NumberedList', 'BulletedList', 'Outdent', 'Indent', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock', 'eplineheight' ] },
            { name: 'media', items : groups["media"] },
            { name: 'various', items : groups["various"].concat(['eptable', 'Anchor', 'HorizontalRule', 'SpecialChar' ]) },
            { name: 'tools', items : [ 'ShowBlocks', 'Source' ] },
            { name: 'close', items : [ 'epalmostfullscreenclose' ] }
        ];

        config.toolbar_FullscreenEmailPreview = [
            { name: 'styles', items : [ 'Undo', 'Redo', 'Find', 'Format', 'Font', 'FontSize', 'RemoveFormat', 'Bold', 'Italic', 'Underline', 'Strike', 'eptextcolor', 'epbgcolor' ] },
            { name: 'paragraph', items : [ 'NumberedList', 'BulletedList', 'Outdent', 'Indent', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock', 'eplineheight' ] },
            { name: 'media', items : groups["media"] },
            { name: 'various', items : groups["various"].concat(['eptable', 'Anchor', 'HorizontalRule', 'SpecialChar' ]) },
            { name: 'tools', items : [ 'ShowBlocks', 'Source' ] },
            '/',
            { name: 'placeholder', items : [ 'epplaceholder' ] },
            { name: 'close', items : [ 'epalmostfullscreenclose' ] }
        ];

        config.toolbar_FullscreenPageBreak = [
            { name: 'styles', items : [ 'Undo', 'Redo', 'Find', 'Format', 'Font', 'FontSize', 'RemoveFormat', 'Bold', 'Italic', 'Underline', 'Strike', 'eptextcolor', 'epbgcolor' ] },
            { name: 'paragraph', items : [ 'NumberedList', 'BulletedList', 'Outdent', 'Indent', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock', 'eplineheight' ] },
            { name: 'media', items : groups["media"] },
            { name: 'various', items : groups["various"].concat(['eptable', 'Anchor', 'HorizontalRule']).concat(groups["forum"]).concat(['SpecialChar']) },
            { name: 'tools', items : [ 'ShowBlocks', 'Source' ] },
            { name: 'close', items : [ 'epalmostfullscreenclose' ] }
        ];

        config.toolbar_LegalPages = [
            { name: 'styles', items : [ 'Undo', 'Redo', 'Format', 'RemoveFormat', 'Bold', 'Italic' ] },
            { name: 'paragraph', items : [ 'NumberedList', 'BulletedList' ] },
            { name: 'various', items : groups["various"] }
        ];
    };

    return CKEDITOR;

});
