/*
 * @Copyright   Copyright 2006-2013, epages GmbH, All Rights Reserved.
 *
 * @module      de_epages.design.ui.alignmentdialog
 *
 * @revision    $$
 */
/*jslint nomen: true, browser: true, vars: true*/
/*global define*/
define('de_epages/design/ui/cookiemessage', [
    'jquery/ui/widget',
    'de_epages',
    '$tmpl!./cookiemessage',
    '$dict!ep/dict',

    'ep/ui/simpledialog',
    'jquery/cookie'
], function ($, de_epages, template, dict) {
    'use strict';

    var COOKIE_NAME = 'epagescookielawcookie',

        COOKIE_VALUE = '1',

        htmlDecode = function (value) {
            return $('<div/>').html(value).text();
        };

    $.widget('ui.designUiCookiemessage', {

        _create: function () {
            // Set cookie if pre accepted by option
            if (this.options.preAccepted) {
                this.accept();
            }

            // Show message if cookie is not accepted already
            if (!this.isAccepted()) {
                this.accept();
                this.render();
            }
        },

        isAccepted: function () {
            return $.cookie(COOKIE_NAME) === COOKIE_VALUE;
        },

        accept: function () {
            $.cookie(COOKIE_NAME, COOKIE_VALUE, {expires: 730}); // Two years expire
        },

        render: function () {
            var self = this;

            this.options.message = htmlDecode(this.options.message);

            // Render template and add element references to the widget instance
            $.extend(this, template(this.options).tmplItem('elements'));

            // Translate attributes
            this.message.find('span').dictParseAttr(dict, 'title');

            // Append renderen elements to the widget content
            this.element.append(this.message);

            // Hide message on click the close button
            self.close.one('click', function () {
                self.message.hide();
            });
        }
    });

    return de_epages;

});